* FOX PRO CODELOCK SAMPLE

* The following return code was generated by using
* the Auth.EXE program. Enter your ProductID
* only and the returned code is what is used
* here. Make sure your product ID is upper
* case when passed to CodeLock functions or
* you will not get a valid return code.
#DEFINE RETCODE 33515
#DEFINE PRODID "MY PROGRAM"
#DEFINE CYPHER "SECRET"

****************************************
****************************************
* main function
*

* use the foxtools library
set library to d:\apps\foxprow\foxtools

* use the codelock procedure lib 
* (unless you declare the functions yourself.
SET PROCEDURE TO "cllib.prg"

* Register the CodeLock functions
=RegCLFunc()

* Turn on Return Code support for extra security.
* by default, codelock functions return 0 (fail) or
* 1 (success). By turning this feature on, a secure
* code will be returned and we can validate it (RETCODE).
=CALLFN(UseRetCF, 1)

* This example will install a 30 day timelock on
* a new installation. If the program was
* previously installed, and the user tries
* to reinstall it to get another 30 days,
* their attempt will fail.

* check to see if codelock has been installed before
* on this machine.
IF (RETCODE = FixRetCode(CALLFN(IsCLInstF,PRODID)))
	? "This program has already been installed before"

	* Check here to see if they have a program
	* lock installed. If not then check to see if there
	* is a time lock.
	STORE SPACE(6) TO RegID
	STORE SPACE(1) TO Nada
	* get key from storage. the key is the registration id 
	* (but could be anything as long as it is unique).
	=CALLFN(GProdRegF,PRODID, @RegID, @Nada, @Nada, @Nada, @Nada, @Nada, @Nada)
	IF (RETCODE == FixRetCode(CALLFN(ChProgLF, PRODID, RegID)))
		? "Program Lock is Secure"

		* go on to run the program, all is well...

	ELSE
		? "Program Lock Failed"

		* check the time lock to see if there is any time left.
		IF (RETCODE = FixRetCode(CALLFN(ChTimeLF, PRODID)))
			? "Still have time left"

			* go on to run the program, all is well...
		
		ELSE
			? "30 day Trial period has expired"

			* do not allow the user to run the program.
		ENDIF

		* you should prompt the user to unlock the program
		* here as well.

	ENDIF
ELSE
	? "First Time Install"

	* generate a unique registration number.
	STORE SPACE(6) TO RegID
	=CALLFN(GenRegIDF, @RegID, 6, 6)

	* Install a time lock for 30 days.
	* IMPORTANT. You must have some type of lock installed
	* before the WriteProductRegistration function will work.
	=CALLFN(InTimeLF,PRODID, 30)
	? "30 day Lock Installed"

	* write registration number to storage.
	=CALLFN(WProdRegF, PRODID, RegID, "", "", "", "", "", "")

	* You would prompt the user here to call for an unlock
	* code and you would then install a program lock.

	* Generate a valid unlock code here so you can compare
	* it with the one the user will enter. use RegIDToProtCode.
	UnlockCode = CALLFN(RIDToProF, CYPHER, RegID)

	* Prompt user with RegID and ask them to enter unlock code.
	* we do not actually do this in this sample.
	UsrEntry = "12345"

	* compare user entry with valid unlock code, if they match,
	* install a program lock.
	IF (UnlockCode = VAL(UsrEntry))
		* Install a program lock.
		CALLFN(InProgLF, PRODID, RegID)

		? "Registration successful"
	ELSE
		? "Registration attempt failed."
	ENDIF
ENDIF
SET PROCEDURE TO



